/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is CopySent2Current.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//Attention: the 'no copy' does not work, if sending a message in offline modus
//          (messages are delivered to the 'sent'-folder)

if(!de) var de={};
if(!de.ggbs) de.ggbs={};
if(!de.ggbs.cs2c) de.ggbs.cs2c={};

if (!de.ggbs.cs2c.mc) de.ggbs.cs2c.mc = function() {
////////////////////////

  var gBase=0x100;
  var gSentAlso=0x10;
  var gTrash=0x20;
  var gDefSent=0x1;

  /* for TB3 see mailnews/base/public/nsMsgFolderFlags.idl
  var gFlagList = { 'MSG_FOLDER_FLAG_VIRTUAL' : 0x0020,
                    'MSG_FOLDER_FLAG_TRASH' : 0x0100,
                    'MSG_FOLDER_FLAG_SENTMAIL' : 0x0200,
                    'MSG_FOLDER_FLAG_DRAFTS' : 0x0400,
                    'MSG_FOLDER_FLAG_QUEUE' : 0x0800,
                    'MSG_FOLDER_FLAG_INBOX' : 0x1000,
                    'MSG_FOLDER_FLAG_TEMPLATES' : 0x400000,
                    'MSG_FOLDER_FLAG_JUNK' : 0x40000000 };
  */
  var gSpecialFolders=0x0100|0x0400|0x0800|0x400000|0x40000000;

  var gConsole;
  var gScriptError;

  var gPreSelected='';

  var gDefaultLabel=null;
  var gDefaultURI=null;
  var gOrigURI=null;
  var gAllowMove=true;

  var gAllowChoose=true;

  var pub = {
    gOrigUri:      null,
    gOrigType:     -1,
    gMsgType:      0,
    gMsgFcc:       '',
    CS2C:          Components.classes["@ggbs.de/copySent2Current;1"]
                      .getService(Components.interfaces.CopySent2Current)
  };
  var TB3=pub.CS2C.TB3;

  //public function are define as
  //  pub.name = function(args) {...}
  //and must be called as de.ggbs.cs2c.mc.name
  //
  //Internal functions are defined normally as
  //  function name(args) {...}
  //and are called without 'this.'

  /////////////////////////////////////////////////////////////////////////////
  // set the fcc_folder, so sendMsg will use it
  pub.prepareForCopy = function() {
    //within this function, the variables have to be used as
    //  de.ggbs.cs2c.mc.gMsgType, not just this.gMsgType!!

  //Get current identity
    if (!gAllowChoose) return;      //no copy requested or copy to fixed folder (standard tb modes)

    var picker=document.getElementById('de-ggbs-cs2c-fccFolderPicker');
    var msgCompFields = gMsgCompose.compFields;

    if (de.ggbs.cs2c.mc.gMsgType==nsIMsgCompDeliverMode.SaveAsDraft ||
        de.ggbs.cs2c.mc.gMsgType==nsIMsgCompDeliverMode.SaveAsTemplate ||
        de.ggbs.cs2c.mc.gMsgType==nsIMsgCompDeliverMode.AutoSaveAsDraft) {
        //for drafts/template save current fcc selection for later use 
      msgCompFields.fcc = picker.getAttribute("uri");
      return;
    }

    // this will be called even if there is no 'To:', but the send will not be performed
    if (!msgCompFields.to && !msgCompFields.cc && !msgCompFields.bcc) return

    var identity=window.getCurrentIdentity();
    var moveToURI='';
    if (!gPreSelected) {
      //If 'choose after send' is enabled, show the menu
      if (de.ggbs.cs2c.mc.CS2C.chooseBehind) {
          //.open() throws exception!
        //var left=window.left+200;
        //var top=window.top+200;
        var chooser=window.openDialog("chrome://copysent2current/content/chooser.xul","cs2c_chooser",
            'chrome=yes,modal=yes,titlebar=yes,alwaysRaised=yes,dialog=yes,close=no',//,left='+left+',top='+top,
            gDefaultLabel, gDefaultURI, gAllowMove);
      }
      var targeturi=picker.getAttribute("uri");
      if (targeturi!="nocopy://"
          && !(identity.fccFolderPickerMode&gDefSent && targeturi==gDefaultURI)
                                         // nicht den sentfolder, wenn er der default ist
      ) {
        de.ggbs.cs2c.mc.CS2C.add_URI(targeturi); //save this uri in the list
      }
      msgCompFields.fcc = targeturi;
      if (targeturi!="nocopy://") moveToURI=targeturi;
    } else if (gPreSelected=='noCopy') {
      msgCompFields.fcc = "nocopy://";
    } else if (gPreSelected=='toSentFolder') {
      msgCompFields.fcc = identity.fccFolder;
      moveToURI=targeturi;
    }

    gPreSelected='';

    if (msgCompFields.fcc=='nocopy://') {
      if (de.ggbs.cs2c.mc.CS2C.no_nocopy) {
        // TB3 has a BUG with 'nocopy://': After doing the work, it performs a normal shutdown 
        // fcc to a nonexistant folder does not work as TB falls back to the sent folder 
        identity.fccFolderPickerMode|=gTrash; // fallback to copy to trash
      }
      if (identity.fccFolderPickerMode&gTrash) {    //nocopy is copy to trash
        //find the Trash folder
        var trashFolder;
        var trashFolderURIs = new Array(identity.fccFolder, 'mailbox://nobody@Local%20Folders');
          //first try trash of current identity, else fallback to trash of 'Local Folders'
        for (var i=0; i<trashFolderURIs.length; i++) {
          var trashFolderURI=trashFolderURIs[i];
          var folder;
          if (typeof MailUtils=='object') { //since TB3b3
            folder=MailUtils.getFolderForURI(trashFolderURI);
          } else {  //TB2-TB3b2, Eudora
            folder=GetMsgFolderFromUri(trashFolderURI);
          }
          var rootFolder = folder.rootFolder;
          try {
            //TB2
            const MSG_FOLDER_FLAG_TRASH = 0x0100;
            var out = new Object();
            var trashFolder = rootFolder.getFoldersWithFlag(MSG_FOLDER_FLAG_TRASH, 1, out);
          } catch(e) {
            //TB3
            var trashFolder = rootFolder.getFolderWithFlags(Components.interfaces.nsMsgFolderFlags.Trash);
          }
          if (trashFolder) break;
        }
  
        if (trashFolder) {
          msgCompFields.fcc=trashFolder.URI;
          moveToURI=de.ggbs.cs2c.mc.CS2C.noMoveTrash?'':trashFolder.URI;
        } else {
          var prompter = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
            getService(Components.interfaces.nsIPromptService);
          var strings = document.getElementById("de-ggbs-cs2c-strings");
          var ret=prompter.alert(window, strings.getString('CopySent2Current'), strings.getString('NoTrashFolder'));
          msgCompFields.fcc=identity.fccFolder;
          moveToURI=identity.fccFolder;
        }
      }
    }
    msgCompFields.fcc2='nocopy://';
    if (identity.fccFolderPickerMode&gSentAlso && msgCompFields.fcc != identity.fccFolder) { // also to sent folder
      if (msgCompFields.fcc=='nocopy://') {
        msgCompFields.fcc  = identity.fccFolder;
      }
      // since fcc2 is only performed when fcc succeeded, we want to be sure
      // that the 'easier'(=copy to a local folder) is done first
      else if (identity.fccFolder.substr(0,7)!='imap://' &&             // if send folder is local
                 msgCompFields.fcc.substr(0,7)=='imap://') {            // and fcc folder is remote
        msgCompFields.fcc2 = msgCompFields.fcc;                         //   change them
        msgCompFields.fcc  = identity.fccFolder;
      } else {
        msgCompFields.fcc2 = identity.fccFolder;
      }
    }

    //Move message if requested and appropriate
    //the message will be moved even if the send fails or gets aborted :-(
    if (gAllowMove && moveToURI && document.getElementById('de-ggbs-cs2c-move').checked) {
      setTimeout(pub.MoveMessage, 100, gOrigURI, moveToURI);
    }

dump('CopySent2Current: fcc  to '+msgCompFields.fcc+'\n');
dump('                  fcc2 to '+msgCompFields.fcc2+'\n');
  }

  pub.MoveMessage = function (msguri, folderuri) {
    try {
      var messenger = Components.classes['@mozilla.org/messenger;1'].createInstance().
          QueryInterface(Components.interfaces.nsIMessenger);
      var msgHdr = messenger.messageServiceFromURI(msguri).messageURIToMsgHdr(msguri);
      if (msgHdr.folder.URI != folderuri) {
        var folder = GetMsgFolderFromUri(folderuri);
        var copyService = Components.classes["@mozilla.org/messenger/messagecopyservice;1"].
                              getService(Components.interfaces.nsIMsgCopyService);
        try {
          //TB2
          var msgs = Components.classes["@mozilla.org/supports-array;1"]
                        .createInstance(Components.interfaces.nsISupportsArray);
          msgs.AppendElement(msgHdr);
          copyService.CopyMessages(msgHdr.folder, msgs, folder,
                   true /* isMove */, null/*listener*/, null /*msgWindow*/, true /* allow undo */);
        } catch(e) {
          //TB3
          var msgs=Components.classes["@mozilla.org/array;1"].
              createInstance(Components.interfaces.nsIMutableArray);
          msgs.appendElement(msgHdr, false);
          copyService.CopyMessages(msgHdr.folder, msgs, folder,
                   true /* isMove */, null/*listener*/, null /*msgWindow*/, true /* allow undo */);
        }
      }
    } catch(e) { alert('Move of original message failed: '+e); }
  }

  //not really used!
  pub.SelectionChange = function (event, picker) {
    var uri=picker.getAttribute("uri");
  }
  /////////////////////////////////////////////////////////////////////////////
  // preselect the current (or another) folder in the 'copy-to'-picker
  // or hide the picker, if not useable
  pub.fillMenu = function(event) {
    try {
      // only works for new windows, not if windows is reopened???
      var ak_s = de.ggbs.cs2c.mc.CS2C.ak_send;
      document.getElementById('de-ggbs-cs2c-key_sendNoCopy').setAttribute('key',ak_s);
      document.getElementById('de-ggbs-cs2c-key_sendCopy2Sent').setAttribute('key',ak_s);
    } catch(e) { alert(e); }

      //origURI: MessageURI if its a reply or some draft/template message
    var origURI=de.ggbs.cs2c.mc.gOrigUri;
    var origType=de.ggbs.cs2c.mc.gOrigType;
//alert('orig='+origURI+' type='+origType);

    gOrigURI=origURI;
    gAllowMove=!(!origURI || origType==9/*draft*/ || origType==10/*template*/);

    if (!de.ggbs.cs2c.mc.CS2C.chooseBehind) de.ggbs.cs2c.mc.addElems();
    document.getElementById('fccMenu').disabled=true;

    var state='';
    var menu=document.getElementById('de-ggbs-cs2c-toolbar');
    var identity=window.getCurrentIdentity();
    if (identity.doFcc && identity.fccFolderPickerMode>=gBase) {
      try {
  	    gAllowChoose=true;
  	    menu.hidden=de.ggbs.cs2c.mc.CS2C.chooseBehind;

        var cb=document.getElementById('de-ggbs-cs2c-move');
        cb.hidden=!gAllowMove;
        if (gAllowMove)
          cb.checked=de.ggbs.cs2c.mc.CS2C.moveMsg;

  	    var sendTo='';
  	    var folder;
  	    if (identity.fccFolderPickerMode&gDefSent) {
  	      // Sent folder is default
  	      sendTo=identity.fccFolder;
          state='isSentFolder';
        } else if (origURI) {
          //this could be a reply or a draft/template message
          var messenger = Components.classes['@mozilla.org/messenger;1'].createInstance().
              QueryInterface(Components.interfaces.nsIMessenger);
          if (origType==9/*draft*/ || origType==10/*template*/) {
            state='draft';

            //try to extract FCC. Would be nice, if i could extract the header
            //unfortunately the following does not work:
            // (but see 'info' add-on, function getMimeHeaders)
            /*
            var uriToOpen=origURI+'?fetchCompleteMessage=true';
            let aUrl={};
            messenger.messageServiceFromURI(origURI).GetUrlForUri(uriToOpen, aUrl, null);
            aUrl=aUrl.value;
            var fUrl=aUrl.QueryInterface(Components.interfaces.nsIMsgMailNewsUrl);
            var mh=fUrl.mimeHeaders;  //--- this fails
            var fcc=mh.extractHeader("fcc", false);
            */
            //therefore i read the content of the message and parse it
            var MsgService = messenger.messageServiceFromURI(origURI);
            var MsgStream = Components.classes["@mozilla.org/network/sync-stream-listener;1"]
                                 .createInstance();
            var MsgStrem_Inputstream = MsgStream.QueryInterface(Components.interfaces.nsIInputStream);
            var ScriptInput = Components.classes["@mozilla.org/scriptableinputstream;1"]
                                 .createInstance();
            var ScriptInputStream = ScriptInput.QueryInterface(Components.interfaces.nsIScriptableInputStream);
            ScriptInputStream.init(MsgStream);
            try {
              MsgService.streamMessage(origURI,MsgStream, null, null, false, null);
            } catch (e) {alert(e); }
            ScriptInputStream.available();
            var content='';
            var found=null;
            while (ScriptInputStream.available()) {
              content+=ScriptInputStream.read(512);
              if ((found=content.match(/^FCC:\s*(.*)$/m))) break;
              if (content.search(/\r\n\r\n/m)>=0) break;
            }
            ScriptInputStream.close();
            var fcc=found?found[1]:'';

            if (fcc) {
              state='haveFCC';
              if (typeof MailUtils=='object') { //since TB3b3
                folder=MailUtils.getFolderForURI(fcc, true);
              } else {  //TB2-TB3b2, Eudora
                folder=GetMsgFolderFromUri(fcc);
              }
            } else {
              //no fcc. Might be a template via 'Edit as new'
              state='noFCC';
              var msgHdr=messenger.msgHdrFromURI(origURI);  //nsIMsgDBHeader
              folder=msgHdr.folder;
            }
          } else {
          //for replies, current folder is the folder of the message replied to!
            state='answer';
            var msgHdr=messenger.msgHdrFromURI(origURI);  //nsIMsgDBHeader
            folder=msgHdr.folder;
          }
  	    } else { //Must be a new message. Try to find the currently selected folder
          state='defaultFolder';
  	      var mailWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
  	                       .QueryInterface(Components.interfaces.nsIWindowMediator)
  	                       .getMostRecentWindow("mail:3pane");
  	      if (mailWindow) {     //else: no main window
            state+=' window';
  	        var View=mailWindow.gDBView;  //nsIMsgDBView
  	        if (View) {         // else: no folder selected!
              state+=' view';
  	          folder=View.msgFolder;
  	          // wenn 'new' geklicked
  	          //TB3b4: wenn tab mit message aktiv, ist das der folder der message,
  	          //         nicht der folder aus dem 3pane tab
  	          //       aus einem der neuen suchergebnis fenster gibts zwar den view,
  	          //         aber der hat keinen folder
  	          //       wenn message in eigenem Window (vom 3pane tab aus), sollte eventuell der folder
  	          //         der angezeigten message genommen werden, nicht aus 3pane window (kein Ahnung wie)
  	          //       wenn message in eigenem Window (aus suchergebnis heraus),
  	          //         gibts keinen folder
  	        }
  	      }
  	    }
        state+=' check';
   	    if (folder && folder.canFileMessages     // not news Folder, virtual folder
      	//        && !(folder.flags&gSpecialFolders)   // not a special folder
        ) {
           state+=' getURI';
           sendTo=folder.URI;
        }
      	//else if (folder) alert('special folder');
      	//else if (!sendTo) alert('no folder');
  	    if (!sendTo) //last resort: preselect last used folder
  	      sendTo=identity.fccFolder;
      } catch(e) {
        if (!gConsole) gConsole = Components.classes["@mozilla.org/consoleservice;1"]
                                  .getService(Components.interfaces.nsIConsoleService);
        if (!gScriptError) gScriptError = Components.classes["@mozilla.org/scripterror;1"]
                                  .createInstance(Components.interfaces.nsIScriptError);
        gScriptError.init('CopySent2Current: Error initializing  ('+e.message+')\n  State: '+state+'\n',
                /*aSourceName*/null, /*aSourceLine*/null, /*aLineNumber*/null,
                       /*aColumnNumber*/null, /*nsIScriptError.warningFlag*/1, '');
        gConsole.logMessage(gScriptError);
      }

      //Set chooser to the default (if choose behind: just to get uri and label!)
        //from chrome:://messenger/content/msgFolderPickerOverlay.js #88ff
      SetFolderPicker(sendTo, "de-ggbs-cs2c-fccFolderPicker");
      var picker=document.getElementById('de-ggbs-cs2c-fccFolderPicker');
      gDefaultLabel=picker.getAttribute("label");
      gDefaultURI=picker.getAttribute("uri");

      if (!de.ggbs.cs2c.mc.CS2C.chooseBehind) {
        var menu=document.getElementById('de-ggbs-cs2c-copyMenuPopup');
        var def=menu.firstChild;
        def.label  = gDefaultLabel;
        def.id     = gDefaultURI;
        de.ggbs.cs2c.mc.fillElems();
      }
    } else {
      gAllowChoose=false;
      menu.hidden=true;
    }
  }

  /////////////////////////////////////////////////////////////////////////////
  // called from the choosebehind chooser on pick
  pub.picked = function(chooser, picked, move) {
    var uri=picked.id;
    var picker=document.getElementById('de-ggbs-cs2c-fccFolderPicker');
    if (uri=='nocopy://') {
      picker.setAttribute("label",picked.getAttribute("label"));
      picker.setAttribute("uri",uri);
    } else {
      //from chrome:://messenger/content/msgFolderPickerOverlay.js #88
      SetFolderPickerElement(uri, picker);
        //Does the following, and adds the '... in server' text to the picker
        //  picker.setAttribute("label",picked.getAttribute("label"));
        //  picker.setAttribute("uri",uri);
    }
    if (chooser) {
      chooser.close();
      chooser=null;
      document.getElementById('de-ggbs-cs2c-move').checked=move;
    }
  }
  pub.showPopup = function() {
    // called via a timeout! This prevents using the keystroke as navigation in the popup,
    // if the menulist gots focus via keyboard-shortcut
    var popup=document.getElementById('de-ggbs-cs2c-copyMenuPopup');
    if (!de.ggbs.cs2c.mc.CS2C.TB3)
      popup.showPopup(popup,-1,-1,'popup','topleft','topleft'); //deprecated; use:
    else
      popup.openPopup(popup, 'after_start', -1, -1, false, false);
  }

  // Register a state listener so that we know, the message has been sent.
  // reset the fcc_folder to the 'sent' folder

  /*
  var cs2c_stateListener = {
    NotifyComposeFieldsReady: function() {
  //dump('NotifyComposeFieldsReady\n');
    },


    // Message send (or copied to outbox, if offline)
    ComposeProcessDone: function(aResult) {
  //dump('ComposeProcessDone\n');
    },

    SaveInFolderDone: function(folderURI) {
  //dump('SaveInFolderDone\n');
    }

  };
  */

  /////////////////////////////////////////////////////////////////////////////
  pub.init = function() {
    de.ggbs.cs2c.mc.fillMenu(null);    // and preselect the current folder in the copy to picker
  }

  pub.Controller =
  {
    supportsCommand: function(command)
    {
  //dump("cs2c: supportsCommand: "+command+"\n");
      switch (command)
      {
        case "de-ggbs-cs2c-cmd_sendNoCopy":
        case "de-ggbs-cs2c-cmd_sendCopy2Sent":
          return true;
        default:
          return false;
      }
    },
    isCommandEnabled: function(command)
    {
  //dump("cs2c: isCommandEnabled: "+command+"\n");
      switch (command)
      {
        case "de-ggbs-cs2c-cmd_sendNoCopy":
        case "de-ggbs-cs2c-cmd_sendCopy2Sent":
          var identity=window.getCurrentIdentity();
          if (!identity.doFcc || identity.fccFolderPickerMode<gBase) return false;
          return !gWindowLocked;
        default:
          return false;
      }
    },

    doCommand: function(command)
    {
  //dump("cs2c: doCommand: "+command+"\n");
      switch (command)
      {
        case "de-ggbs-cs2c-cmd_sendNoCopy":
          if (de.ggbs.cs2c.mc.Controller.isCommandEnabled(command)) {
            gPreSelected='noCopy';
            if (gIOService && gIOService.offline)
              SendMessageLater();
            else
              SendMessage();
          }
          break;
        case "de-ggbs-cs2c-cmd_sendCopy2Sent":
          if (de.ggbs.cs2c.mc.Controller.isCommandEnabled(command)) {
            gPreSelected='toSentFolder';
            if (gIOService && gIOService.offline)
              SendMessageLater();
            else
              SendMessage();
          }
          break;
        default:
          return;
      }
    },

    onEvent: function(event)
    {
  //dump("DefaultController:onEvent\n");
    }
  }

  return pub;

}();


/////////////////////////////////////////////////////////////////////////////
// Overload from chrome://messenger/content/msgComposeCommands.js @line 1163
// not via init(), because that might be too late!
function ComposeStartup(recycled, aParams) {
  de.ggbs.cs2c.ol.savedComposeStartup(recycled, aParams);   // call original
//  gMsgCompose.RegisterStateListener(cs2c_stateListener);  // i want to know state changes

  //see original ComposeStartup
  var params=null;
  var origURI=null;
  var origType=-1;
  if (aParams)
    params = aParams;
  else
    if (window.arguments && window.arguments[0]) {
      try {
        if (window.arguments[0] instanceof Components.interfaces.nsIMsgComposeParams)
          params = window.arguments[0];
        else
          params = handleMailtoArgs(window.arguments[0]);
      }
      catch(ex) { dump("ERROR with parameters: " + ex + "\n"); }
    }
  if (params) {
    origURI=params.originalMsgURI;
    origType=params.type;
    //params.originalMsgHdr;
    //      .originalMsgURI;
    //      .identity;
    //      .type; //This is not the same as type in GenericSendMessage
    //params.composeFields.draftId
    //                    .to
    //                    .messageId
    //                    .body
    //                    .ConvertBodyToPlainText (a function)
    //                    .fcc='' //:-(((
    //                    .fcc2=''
  }// else alert('no params');  // e.g. called via 'thunderbird -compose'
  de.ggbs.cs2c.mc.gOrigUri=origURI;
  de.ggbs.cs2c.mc.gOrigType=origType;

}

// Overload from chrome://messenger/content/msgComposeCommands.js @line 1646
// so we have a chance to get the type of the message
// because we do not want to set .fcc and .fcc2 on SaveAsDraft and others
window.GenericSendMessage=function() {
  de.ggbs.cs2c.mc.gMsgType=arguments[0];
  return de.ggbs.cs2c.ol.savedGenericSendMessage.apply(this, arguments);
}

top.controllers.insertControllerAt(0, de.ggbs.cs2c.mc.Controller);

// Call when the window is fully loaded, prevent racing condition
window.addEventListener("load", de.ggbs.cs2c.mc.init, false);                      //first open, calls fillMenu
window.addEventListener('compose-window-reopen', de.ggbs.cs2c.mc.fillMenu, true);  //reopen
window.addEventListener('compose-from-changed', de.ggbs.cs2c.mc.fillMenu, true);   //change of identity! (last param must be true!)

window.addEventListener('compose-send-message', de.ggbs.cs2c.mc.prepareForCopy, true); // fires after the observer 'mail:composeOnSend'
